!
! auto-generated by op2.py
!

MODULE BRES_CALC_MODULE
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING
USE OP2_CONSTANTS

#ifdef _OPENMP
  USE OMP_LIB
#endif


CONTAINS

! user function
#include "bres_calc.inc"


SUBROUTINE op_wrap_bres_calc( &
  & opDat1Local, &
  & opDat3Local, &
  & opDat4Local, &
  & opDat5Local, &
  & opDat6Local, &
  & opDat1Map, &
  & opDat1MapDim, &
  & opDat3Map, &
  & opDat3MapDim, &
  & bottom,top)
  implicit none
  real(8) opDat1Local(2,*)
  real(8) opDat3Local(4,*)
  real(8) opDat4Local(1,*)
  real(8) opDat5Local(4,*)
  integer opDat6Local(1,*)
  INTEGER(kind=4) opDat1Map(*)
  INTEGER(kind=4) opDat1MapDim
  INTEGER(kind=4) opDat3Map(*)
  INTEGER(kind=4) opDat3MapDim
  INTEGER(kind=4) bottom,top,i1
  INTEGER(kind=4) map1idx, map2idx, map3idx

  DO i1 = bottom, top-1, 1
    map1idx = opDat1Map(1 + i1 * opDat1MapDim + 0)+1
    map2idx = opDat1Map(1 + i1 * opDat1MapDim + 1)+1
    map3idx = opDat3Map(1 + i1 * opDat3MapDim + 0)+1
! kernel call
  CALL bres_calc( &
    & opDat1Local(1,map1idx), &
    & opDat1Local(1,map2idx), &
    & opDat3Local(1,map3idx), &
    & opDat4Local(1,map3idx), &
    & opDat5Local(1,map3idx), &
    & opDat6Local(1,i1+1) &
    & )
  END DO
END SUBROUTINE
SUBROUTINE bres_calc_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5, &
  & opArg6 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5
  type ( op_arg ) , INTENT(IN) :: opArg6

  type ( op_arg ) , DIMENSION(6) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat1Map
  INTEGER(kind=4) :: opDat1MapDim
  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat3Map
  INTEGER(kind=4) :: opDat3MapDim
  real(8), POINTER, DIMENSION(:) :: opDat3Local
  INTEGER(kind=4) :: opDat3Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat4Map
  INTEGER(kind=4) :: opDat4MapDim
  real(8), POINTER, DIMENSION(:) :: opDat4Local
  INTEGER(kind=4) :: opDat4Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat5Map
  INTEGER(kind=4) :: opDat5MapDim
  real(8), POINTER, DIMENSION(:) :: opDat5Local
  INTEGER(kind=4) :: opDat5Cardinality

  integer, POINTER, DIMENSION(:) :: opDat6Local
  INTEGER(kind=4) :: opDat6Cardinality

  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  LOGICAL :: firstTime_bres_calc = .TRUE.
  type ( c_ptr )  :: planRet_bres_calc
  type ( op_plan ) , POINTER :: actualPlan_bres_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: ncolblk_bres_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: blkmap_bres_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: nelems_bres_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: offset_bres_calc
  INTEGER(kind=4), DIMENSION(1:6) :: indirectionDescriptorArray
  INTEGER(kind=4) :: numberOfIndirectOpDats
  INTEGER(kind=4) :: blockOffset
  INTEGER(kind=4) :: nblocks
  INTEGER(kind=4) :: partitionSize
  INTEGER(kind=4) :: blockID
  INTEGER(kind=4) :: nelem
  INTEGER(kind=4) :: offset_b


  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 6

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5
  opArgArray(6) = opArg6

  returnSetKernelTiming = setKernelTime(3 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges(set%setCPtr,numberOfOpDats,opArgArray)

#ifdef OP_PART_SIZE_1
  partitionSize = OP_PART_SIZE_1
#else
  partitionSize = 0
#endif

#ifdef _OPENMP
  numberOfThreads = omp_get_max_threads()
#else
  numberOfThreads = 1
#endif
    indirectionDescriptorArray(1) = 0
    indirectionDescriptorArray(2) = 0
    indirectionDescriptorArray(3) = 1
    indirectionDescriptorArray(4) = 2
    indirectionDescriptorArray(5) = 3
    indirectionDescriptorArray(6) = -1

    numberOfIndirectOpDats = 4

    planRet_bres_calc = FortranPlanCaller( &
    & userSubroutine//C_NULL_CHAR, &
    & set%setCPtr, &
    & partitionSize, &
    & numberOfOpDats, &
    & opArgArray, &
    & numberOfIndirectOpDats, &
    & indirectionDescriptorArray,2)

    CALL c_f_pointer(planRet_bres_calc,actualPlan_bres_calc)
    CALL c_f_pointer(actualPlan_bres_calc%ncolblk,ncolblk_bres_calc,(/actualPlan_bres_calc%ncolors_core/))
    CALL c_f_pointer(actualPlan_bres_calc%blkmap,blkmap_bres_calc,(/actualPlan_bres_calc%nblocks/))
    CALL c_f_pointer(actualPlan_bres_calc%offset,offset_bres_calc,(/actualPlan_bres_calc%nblocks/))
    CALL c_f_pointer(actualPlan_bres_calc%nelems,nelems_bres_calc,(/actualPlan_bres_calc%nblocks/))

    opSetCore => set%setPtr

    opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
    opDat1MapDim = getMapDimFromOpArg(opArg1)
    opDat3Cardinality = opArg3%dim * getSetSizeFromOpArg(opArg3)
    opDat3MapDim = getMapDimFromOpArg(opArg3)
    opDat4Cardinality = opArg4%dim * getSetSizeFromOpArg(opArg4)
    opDat4MapDim = getMapDimFromOpArg(opArg4)
    opDat5Cardinality = opArg5%dim * getSetSizeFromOpArg(opArg5)
    opDat5MapDim = getMapDimFromOpArg(opArg5)
    opDat6Cardinality = opArg6%dim * getSetSizeFromOpArg(opArg6)
    CALL c_f_pointer(opArg1%data,opDat1Local,(/opDat1Cardinality/))
    CALL c_f_pointer(opArg1%map_data,opDat1Map,(/opSetCore%size*opDat1MapDim/))
    CALL c_f_pointer(opArg3%data,opDat3Local,(/opDat3Cardinality/))
    CALL c_f_pointer(opArg3%map_data,opDat3Map,(/opSetCore%size*opDat3MapDim/))
    CALL c_f_pointer(opArg4%data,opDat4Local,(/opDat4Cardinality/))
    CALL c_f_pointer(opArg4%map_data,opDat4Map,(/opSetCore%size*opDat4MapDim/))
    CALL c_f_pointer(opArg5%data,opDat5Local,(/opDat5Cardinality/))
    CALL c_f_pointer(opArg5%map_data,opDat5Map,(/opSetCore%size*opDat5MapDim/))
    CALL c_f_pointer(opArg6%data,opDat6Local,(/opDat6Cardinality/))


    blockOffset = 0

    DO i1 = 0, actualPlan_bres_calc%ncolors-1, 1
      IF (i1 .EQ. actualPlan_bres_calc%ncolors_core) THEN
        CALL op_mpi_wait_all(numberOfOpDats,opArgArray)
      END IF

      nblocks = ncolblk_bres_calc(i1 + 1)
      !$OMP PARALLEL DO private (threadID, blockID, nelem, offset_b)
      DO i2 = 0, nblocks-1, 1
        threadID = omp_get_thread_num()
        blockID = blkmap_bres_calc(i2+blockOffset+1)
        nelem = nelems_bres_calc(blockID+1)
        offset_b = offset_bres_calc(blockID+1)
        CALL op_wrap_bres_calc( &
        & opDat1Local, &
        & opDat3Local, &
        & opDat4Local, &
        & opDat5Local, &
        & opDat6Local, &
        & opDat1Map, &
        & opDat1MapDim, &
        & opDat3Map, &
        & opDat3MapDim, &
        & offset_b, offset_b+nelem)
      END DO
      !$OMP END PARALLEL DO
      blockOffset = blockOffset + nblocks
    END DO
    IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
      CALL op_mpi_wait_all(numberOfOpDats,opArgArray)
    END IF

    CALL op_mpi_set_dirtybit(numberOfOpDats,opArgArray)

    call op_timers_core(endTime)

    returnSetKernelTiming = setKernelTime(3 , userSubroutine//C_NULL_CHAR, &
    & endTime-startTime, actualPlan_bres_calc%transfer,actualPlan_bres_calc%transfer2, 1)
  END SUBROUTINE
  END MODULE