!
! auto-generated by op2.py
!

MODULE BRES_CALC_MODULE
USE OP2_CONSTANTS
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING

#ifdef _OPENMP
  USE OMP_LIB
#endif


! bres_calcvariable declarations



CONTAINS

! user function
SUBROUTINE bres_calc_gpu(x1,x2,q1,adt1,res1,bound)
  IMPLICIT NONE
  REAL(kind=8), DIMENSION(2) :: x1
  REAL(kind=8), DIMENSION(2) :: x2
  REAL(kind=8), DIMENSION(4) :: q1
  REAL(kind=8) :: adt1
  REAL(kind=8), DIMENSION(4) :: res1
  INTEGER(kind=4) :: bound
  REAL(kind=8) :: dx,dy,mu,ri,p1,vol1,p2,vol2,f

  dx = x1(1) - x2(1)
  dy = x1(2) - x2(2)
  ri = 1.0 / q1(1)
  p1 = gm1 * (q1(4) - 0.5 * ri * (q1(2) * q1(2) + q1(3) * q1(3)))

  IF (bound .EQ. 1) THEN
    res1(2) = res1(2) + p1 * dy
    res1(3) = res1(3) -(p1 * dx)
  ELSE
    vol1 = ri * (q1(2) * dy - q1(3) * dx)
    ri = 1.0 / qinf(1)
    p2 = gm1 * (qinf(4) - 0.5 * ri * (qinf(2) * qinf(2) + qinf(3) * qinf(3)))
    vol2 = ri * (qinf(2) * dy - qinf(3) * dx)
    mu = adt1 * eps
    f = 0.5 * (vol1 * q1(1) + vol2 * qinf(1)) + mu * (q1(1) - qinf(1))
    res1(1) = res1(1) + f
    f = 0.5 * (vol1 * q1(2) + p1 * dy + vol2 * qinf(2) + p2 * dy) + mu * (q1(2) - qinf(2))
    res1(2) = res1(2) + f
    f = 0.5 * (vol1 * q1(3) - p1 * dx + vol2 * qinf(3) - p2 * dx) + mu * (q1(3) - qinf(3))
    res1(3) = res1(3) + f
    f = 0.5 * (vol1 * (q1(4) + p1) + vol2 * (qinf(4) + p2)) + mu * (q1(4) - qinf(4))
    res1(4) = res1(4) + f
  END IF
END SUBROUTINE


SUBROUTINE op_wrap_bres_calc( &
  & opDat1Local, &
  & opDat1Size, &
  & opDat3Local, &
  & opDat3Size, &
  & opDat4Local, &
  & opDat4Size, &
  & opDat5Local, &
  & opDat5Size, &
  & opDat6Local, &
  & opDat1Map, &
  & opDat1MapDim, &
  & opDat3Map, &
  & opDat3MapDim, &
  & col_reord, set_size, &
  & bottom,top,set_size_full)
  implicit none
  INTEGER(kind=4) set_size
  INTEGER(kind=4) col_reord(set_size)
  INTEGER(kind=4) set_size_full
  INTEGER(kind=4) opDat1Size
  real(8) opDat1Local(2,opDat1Size)
  INTEGER(kind=4) opDat3Size
  real(8) opDat3Local(4,opDat3Size)
  INTEGER(kind=4) opDat4Size
  real(8) opDat4Local(1,opDat4Size)
  INTEGER(kind=4) opDat5Size
  real(8) opDat5Local(4,opDat5Size)
  integer opDat6Local(1,set_size_full)
  INTEGER(kind=4) opDat1MapDim
  INTEGER(kind=4) opDat1Map(opDat1MapDim*set_size)
  INTEGER(kind=4) opDat3MapDim
  INTEGER(kind=4) opDat3Map(opDat3MapDim*set_size)

  INTEGER(kind=4) bottom,top,i1,i2
  INTEGER(kind=4) map1idx, map2idx, map3idx


  !$omp target teams distribute parallel do &
!$omp& map(to:opDat1Local) &
!$omp& map(to:opDat3Local) &
!$omp& map(to:opDat4Local) &
!$omp& map(to:opDat5Local) &
!$omp& map(to:opDat6Local) &
!$omp& map(to:opDat1Map) &
!$omp& map(to:opDat3Map) &
!$omp& map(to:col_reord) private(i1) &
!$omp& private(map1idx) &
!$omp& private(map2idx) &
!$omp& private(map3idx) 
  DO i2 = bottom, top-1, 1
    i1 = col_reord(i2+1)
    map1idx = opDat1Map(1 + i1 + set_size * 0)+1
    map2idx = opDat1Map(1 + i1 + set_size * 1)+1
    map3idx = opDat3Map(1 + i1 + set_size * 0)+1
! kernel call
    CALL bres_calc_gpu( &
    & opDat1Local(1,map1idx), &
    & opDat1Local(1,map2idx), &
    & opDat3Local(1,map3idx), &
    & opDat4Local(1,map3idx), &
    & opDat5Local(1,map3idx), &
    & opDat6Local(1,i1+1) &
    & )
  END DO
  !$omp end target teams distribute parallel do

END SUBROUTINE
SUBROUTINE bres_calc_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5, &
  & opArg6 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5
  type ( op_arg ) , INTENT(IN) :: opArg6

  type ( op_arg ) , DIMENSION(6) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat1Map
  INTEGER(kind=4) :: opDat1MapDim
  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat3Map
  INTEGER(kind=4) :: opDat3MapDim
  real(8), POINTER, DIMENSION(:) :: opDat3Local
  INTEGER(kind=4) :: opDat3Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat4Map
  INTEGER(kind=4) :: opDat4MapDim
  real(8), POINTER, DIMENSION(:) :: opDat4Local
  INTEGER(kind=4) :: opDat4Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat5Map
  INTEGER(kind=4) :: opDat5MapDim
  real(8), POINTER, DIMENSION(:) :: opDat5Local
  INTEGER(kind=4) :: opDat5Cardinality

  integer, POINTER, DIMENSION(:) :: opDat6Local
  INTEGER(kind=4) :: opDat6Cardinality

  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  INTEGER(kind=4), SAVE :: calledTimes=0
  INTEGER(kind=4) :: exec_size
  LOGICAL :: firstTime_bres_calc = .TRUE.
  type ( c_ptr )  :: planRet_bres_calc
  type ( op_plan ) , POINTER :: actualPlan_bres_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: col_reord_bres_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: offset_bres_calc
  INTEGER(kind=4), DIMENSION(1:6) :: indirectionDescriptorArray
  INTEGER(kind=4) :: numberOfIndirectOpDats
  INTEGER(kind=4) :: nblocks
  INTEGER(kind=4) :: partitionSize
  INTEGER(kind=4) :: blockID
  INTEGER(kind=4) :: nelem
  INTEGER(kind=4) :: offset_b


  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 6

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5
  opArgArray(6) = opArg6

  returnSetKernelTiming = setKernelTime(3 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges_cuda(set%setCPtr,numberOfOpDats,opArgArray)

  opSetCore => set%setPtr

  indirectionDescriptorArray(1) = 0
  indirectionDescriptorArray(2) = 0
  indirectionDescriptorArray(3) = 1
  indirectionDescriptorArray(4) = 2
  indirectionDescriptorArray(5) = 3
  indirectionDescriptorArray(6) = -1

  exec_size = opSetCore%size + opSetCore%exec_size
  numberOfIndirectOpDats = 4

  partitionSize=0
  planRet_bres_calc = FortranPlanCaller( &
  & userSubroutine//C_NULL_CHAR, &
  & set%setCPtr, &
  & partitionSize, &
  & numberOfOpDats, &
  & opArgArray, &
  & numberOfIndirectOpDats, &
  & indirectionDescriptorArray,4)

  CALL c_f_pointer(planRet_bres_calc,actualPlan_bres_calc)
  CALL c_f_pointer(actualPlan_bres_calc%col_reord,col_reord_bres_calc,(/exec_size/))
  CALL c_f_pointer(actualPlan_bres_calc%color2_offsets,offset_bres_calc,(/actualPlan_bres_calc%ncolors+1/))
  opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
  opDat1MapDim = getMapDimFromOpArg(opArg1)
  opDat3Cardinality = opArg3%dim * getSetSizeFromOpArg(opArg3)
  opDat3MapDim = getMapDimFromOpArg(opArg3)
  opDat4Cardinality = opArg4%dim * getSetSizeFromOpArg(opArg4)
  opDat4MapDim = getMapDimFromOpArg(opArg4)
  opDat5Cardinality = opArg5%dim * getSetSizeFromOpArg(opArg5)
  opDat5MapDim = getMapDimFromOpArg(opArg5)
  opDat6Cardinality = opArg6%dim * getSetSizeFromOpArg(opArg6)
  CALL c_f_pointer(opArg1%data_d,opDat1Local,(/opDat1Cardinality/))
  CALL c_f_pointer(opArg1%map_data_d,opDat1Map,(/exec_size*opDat1MapDim/))
  CALL c_f_pointer(opArg3%data_d,opDat3Local,(/opDat3Cardinality/))
  CALL c_f_pointer(opArg3%map_data_d,opDat3Map,(/exec_size*opDat3MapDim/))
  CALL c_f_pointer(opArg4%data_d,opDat4Local,(/opDat4Cardinality/))
  CALL c_f_pointer(opArg4%map_data_d,opDat4Map,(/exec_size*opDat4MapDim/))
  CALL c_f_pointer(opArg5%data_d,opDat5Local,(/opDat5Cardinality/))
  CALL c_f_pointer(opArg5%map_data_d,opDat5Map,(/exec_size*opDat5MapDim/))
  CALL c_f_pointer(opArg6%data_d,opDat6Local,(/opDat6Cardinality/))



  DO i1 = 0, actualPlan_bres_calc%ncolors-1, 1
    IF (i1 .EQ. 1) THEN
      CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
    END IF

    offset_b = offset_bres_calc(i1 + 1)
    nelem = offset_bres_calc(i1 + 1 + 1)
    CALL op_wrap_bres_calc( &
    & opDat1Local, &
    & getSetSizeFromOpArg(opArg1), &
    & opDat3Local, &
    & getSetSizeFromOpArg(opArg3), &
    & opDat4Local, &
    & getSetSizeFromOpArg(opArg4), &
    & opDat5Local, &
    & getSetSizeFromOpArg(opArg5), &
    & opDat6Local, &
    & opDat1Map, &
    & opDat1MapDim, &
    & opDat3Map, &
    & opDat3MapDim, &
    & col_reord_bres_calc, exec_size, offset_b, nelem, exec_size+opSetCore%nonexec_size )
  END DO
  IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
    CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
  END IF

  CALL op_mpi_set_dirtybit_cuda(numberOfOpDats,opArgArray)

  call op_timers_core(endTime)

  returnSetKernelTiming = setKernelTime(3 , userSubroutine//C_NULL_CHAR, &
  & endTime-startTime, actualPlan_bres_calc%transfer,actualPlan_bres_calc%transfer2, 1)
  calledTimes = calledTimes + 1
END SUBROUTINE
END MODULE