!
! auto-generated by op2.py
!

MODULE RES_CALC_MODULE
USE OP2_CONSTANTS
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING

#ifdef _OPENMP
  USE OMP_LIB
#endif


! res_calcvariable declarations



CONTAINS

! user function
subroutine res_calc_gpu(x1,x2,q1,q2,adt1,adt2,res1,res2)
!$acc routine seq
  IMPLICIT NONE
  REAL(kind=8), DIMENSION(2) :: x1
  REAL(kind=8), DIMENSION(2), INTENT(IN) :: x2
  REAL(kind=8), DIMENSION(4), INTENT(IN) :: q1
  REAL(kind=8), DIMENSION(4), INTENT(IN) :: q2
  REAL(kind=8), INTENT(IN) :: adt1
  REAL(kind=8), INTENT(IN) :: adt2
  REAL(kind=8), DIMENSION(4) :: res1
  REAL(kind=8), DIMENSION(4) :: res2
  REAL(kind=8) :: dx,dy,mu,ri,p1,vol1,p2,vol2,f

  dx = x1(1) - x2(1)
  dy = x1(2) - x2(2)
  ri = 1.0 / q1(1)
  p1 = gm1 * (q1(4) - 0.5 * ri * (q1(2) * q1(2) + q1(3) * q1(3)))
  vol1 = ri * (q1(2) * dy - q1(3) * dx)
  ri = 1.0 / q2(1)
  p2 = gm1 * (q2(4) - 0.5 * ri * (q2(2) * q2(2) + q2(3) * q2(3)))
  vol2 = ri * (q2(2) * dy - q2(3) * dx)
  mu = 0.5 * (adt1 + adt2) * eps
  f = 0.5 * (vol1 * q1(1) + vol2 * q2(1)) + mu * (q1(1) - q2(1))
  res1(1) = res1(1) + f
  res2(1) = res2(1) - f
  f = 0.5 * (vol1 * q1(2) + p1 * dy + vol2 * q2(2) + p2 * dy) + mu * (q1(2) - q2(2))
  res1(2) = res1(2) + f
  res2(2) = res2(2) - f
  f = 0.5 * (vol1 * q1(3) - p1 * dx + vol2 * q2(3) - p2 * dx) + mu * (q1(3) - q2(3))
  res1(3) = res1(3) + f
  res2(3) = res2(3) - f
  f = 0.5 * (vol1 * (q1(4) + p1) + vol2 * (q2(4) + p2)) + mu * (q1(4) - q2(4))
  res1(4) = res1(4) + f
  res2(4) = res2(4) - f
END SUBROUTINE


SUBROUTINE op_wrap_res_calc( &
  & opDat1Local, &
  & opDat3Local, &
  & opDat5Local, &
  & opDat7Local, &
  & opDat1Map, &
  & opDat1MapDim, &
  & opDat3Map, &
  & opDat3MapDim, &
  & col_reord, set_size, &
  & bottom,top)
  implicit none
  real(8) opDat1Local(2,*)
  real(8) opDat3Local(4,*)
  real(8) opDat5Local(1,*)
  real(8) opDat7Local(4,*)
  INTEGER(kind=4) opDat1Map(*)
  INTEGER(kind=4) opDat1MapDim
  INTEGER(kind=4) opDat3Map(*)
  INTEGER(kind=4) opDat3MapDim
  INTEGER(kind=4) col_reord(*)
  INTEGER(kind=4) set_size

  INTEGER(kind=4) bottom,top,i1,i2
  INTEGER(kind=4) map1idx, map2idx, map3idx, map4idx


  !$acc parallel loop independent gang vector &
!$acc& deviceptr(opDat1Local) &
!$acc& deviceptr(opDat3Local) &
!$acc& deviceptr(opDat5Local) &
!$acc& deviceptr(opDat7Local) &
!$acc& deviceptr(opDat1Map) &
!$acc& deviceptr(opDat3Map) &
!$acc& deviceptr(col_reord) private(i1) &
!$acc& private(map1idx) &
!$acc& private(map2idx) &
!$acc& private(map3idx) &
!$acc& private(map4idx) 
  DO i2 = bottom, top-1, 1
    i1 = col_reord(i2+1)
    map1idx = opDat1Map(1 + i1 + set_size * 0)+1
    map2idx = opDat1Map(1 + i1 + set_size * 1)+1
    map3idx = opDat3Map(1 + i1 + set_size * 0)+1
    map4idx = opDat3Map(1 + i1 + set_size * 1)+1
! kernel call
    CALL res_calc_gpu( &
    & opDat1Local(1,map1idx), &
    & opDat1Local(1,map2idx), &
    & opDat3Local(1,map3idx), &
    & opDat3Local(1,map4idx), &
    & opDat5Local(1,map3idx), &
    & opDat5Local(1,map4idx), &
    & opDat7Local(1,map3idx), &
    & opDat7Local(1,map4idx) &
    & )
  END DO

END SUBROUTINE
SUBROUTINE res_calc_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5, &
  & opArg6, &
  & opArg7, &
  & opArg8 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5
  type ( op_arg ) , INTENT(IN) :: opArg6
  type ( op_arg ) , INTENT(IN) :: opArg7
  type ( op_arg ) , INTENT(IN) :: opArg8

  type ( op_arg ) , DIMENSION(8) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat1Map
  INTEGER(kind=4) :: opDat1MapDim
  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat3Map
  INTEGER(kind=4) :: opDat3MapDim
  real(8), POINTER, DIMENSION(:) :: opDat3Local
  INTEGER(kind=4) :: opDat3Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat5Map
  INTEGER(kind=4) :: opDat5MapDim
  real(8), POINTER, DIMENSION(:) :: opDat5Local
  INTEGER(kind=4) :: opDat5Cardinality

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat7Map
  INTEGER(kind=4) :: opDat7MapDim
  real(8), POINTER, DIMENSION(:) :: opDat7Local
  INTEGER(kind=4) :: opDat7Cardinality

  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  INTEGER(kind=4), SAVE :: calledTimes=0
  INTEGER(kind=4) :: exec_size
  LOGICAL :: firstTime_res_calc = .TRUE.
  type ( c_ptr )  :: planRet_res_calc
  type ( op_plan ) , POINTER :: actualPlan_res_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: col_reord_res_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: offset_res_calc
  INTEGER(kind=4), DIMENSION(1:8) :: indirectionDescriptorArray
  INTEGER(kind=4) :: numberOfIndirectOpDats
  INTEGER(kind=4) :: nblocks
  INTEGER(kind=4) :: partitionSize
  INTEGER(kind=4) :: blockID
  INTEGER(kind=4) :: nelem
  INTEGER(kind=4) :: offset_b


  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 8

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5
  opArgArray(6) = opArg6
  opArgArray(7) = opArg7
  opArgArray(8) = opArg8

  returnSetKernelTiming = setKernelTime(2 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges_cuda(set%setCPtr,numberOfOpDats,opArgArray)

  opSetCore => set%setPtr

  indirectionDescriptorArray(1) = 0
  indirectionDescriptorArray(2) = 0
  indirectionDescriptorArray(3) = 1
  indirectionDescriptorArray(4) = 1
  indirectionDescriptorArray(5) = 2
  indirectionDescriptorArray(6) = 2
  indirectionDescriptorArray(7) = 3
  indirectionDescriptorArray(8) = 3

  exec_size = opSetCore%size + opSetCore%exec_size
  numberOfIndirectOpDats = 4
  partitionSize = 128 !no effect here, just have to set

  partitionSize=0
  planRet_res_calc = FortranPlanCaller( &
  & userSubroutine//C_NULL_CHAR, &
  & set%setCPtr, &
  & partitionSize, &
  & numberOfOpDats, &
  & opArgArray, &
  & numberOfIndirectOpDats, &
  & indirectionDescriptorArray,4)

  CALL c_f_pointer(planRet_res_calc,actualPlan_res_calc)
  CALL c_f_pointer(actualPlan_res_calc%col_reord,col_reord_res_calc,(/exec_size/))
  CALL c_f_pointer(actualPlan_res_calc%color2_offsets,offset_res_calc,(/actualPlan_res_calc%ncolors+1/))
  opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
  opDat1MapDim = getMapDimFromOpArg(opArg1)
  opDat3Cardinality = opArg3%dim * getSetSizeFromOpArg(opArg3)
  opDat3MapDim = getMapDimFromOpArg(opArg3)
  opDat5Cardinality = opArg5%dim * getSetSizeFromOpArg(opArg5)
  opDat5MapDim = getMapDimFromOpArg(opArg5)
  opDat7Cardinality = opArg7%dim * getSetSizeFromOpArg(opArg7)
  opDat7MapDim = getMapDimFromOpArg(opArg7)
  CALL c_f_pointer(opArg1%data_d,opDat1Local,(/opDat1Cardinality/))
  CALL c_f_pointer(opArg1%map_data_d,opDat1Map,(/exec_size*opDat1MapDim/))
  CALL c_f_pointer(opArg3%data_d,opDat3Local,(/opDat3Cardinality/))
  CALL c_f_pointer(opArg3%map_data_d,opDat3Map,(/exec_size*opDat3MapDim/))
  CALL c_f_pointer(opArg5%data_d,opDat5Local,(/opDat5Cardinality/))
  CALL c_f_pointer(opArg5%map_data_d,opDat5Map,(/exec_size*opDat5MapDim/))
  CALL c_f_pointer(opArg7%data_d,opDat7Local,(/opDat7Cardinality/))
  CALL c_f_pointer(opArg7%map_data_d,opDat7Map,(/exec_size*opDat7MapDim/))



  DO i1 = 0, actualPlan_res_calc%ncolors-1, 1
    IF (i1 .EQ. 1) THEN
      CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
    END IF

    offset_b = offset_res_calc(i1 + 1)
    nelem = offset_res_calc(i1 + 1 + 1)
    CALL op_wrap_res_calc( &
    & opDat1Local, &
    & opDat3Local, &
    & opDat5Local, &
    & opDat7Local, &
    & opDat1Map, &
    & opDat1MapDim, &
    & opDat3Map, &
    & opDat3MapDim, &
    & col_reord_res_calc, exec_size, offset_b, nelem )
  END DO
  IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
    CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
  END IF

  CALL op_mpi_set_dirtybit_cuda(numberOfOpDats,opArgArray)

  call op_timers_core(endTime)

  returnSetKernelTiming = setKernelTime(2 , userSubroutine//C_NULL_CHAR, &
  & endTime-startTime, actualPlan_res_calc%transfer,actualPlan_res_calc%transfer2, 1)
  calledTimes = calledTimes + 1
END SUBROUTINE
END MODULE