!
! auto-generated by op2.py
!

MODULE SAVE_SOLN_MODULE
USE OP2_CONSTANTS
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING

#ifdef _OPENMP
  USE OMP_LIB
#endif


! save_solnvariable declarations



CONTAINS

! user function
subroutine save_soln_gpu(q,qold)
!$acc routine seq
  IMPLICIT NONE

  REAL(kind=8), DIMENSION(4), INTENT(IN) :: q
  REAL(kind=8), DIMENSION(4) :: qold
  INTEGER(kind=4) :: i

  DO i = 1, 4
    qold(i) = q(i)
  END DO
END SUBROUTINE


SUBROUTINE op_wrap_save_soln( &
  & opDat1Local, &
  & opDat2Local, &
  & bottom,top)
  implicit none
  real(8) opDat1Local(4,*)
  real(8) opDat2Local(4,*)

  INTEGER(kind=4) bottom,top,i1,i2


  !$acc parallel loop independent gang vector &
!$acc& deviceptr(opDat1Local) &
!$acc& deviceptr(opDat2Local) 
  DO i1 = bottom, top-1, 1
! kernel call
    CALL save_soln_gpu( &
    & opDat1Local(1,i1+1), &
    & opDat2Local(1,i1+1) &
    & )
  END DO

END SUBROUTINE
SUBROUTINE save_soln_host( userSubroutine, set, &
  & opArg1, &
  & opArg2 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2

  type ( op_arg ) , DIMENSION(2) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat2Local
  INTEGER(kind=4) :: opDat2Cardinality

  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  INTEGER(kind=4), SAVE :: calledTimes=0
  INTEGER(kind=4) :: sliceStart
  INTEGER(kind=4) :: sliceEnd
  REAL(kind=4) :: dataTransfer


  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 2

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2

  returnSetKernelTiming = setKernelTime(0 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges_cuda(set%setCPtr,numberOfOpDats,opArgArray)

  opSetCore => set%setPtr

  opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
  opDat2Cardinality = opArg2%dim * getSetSizeFromOpArg(opArg2)
  CALL c_f_pointer(opArg1%data_d,opDat1Local,(/opDat1Cardinality/))
  CALL c_f_pointer(opArg2%data_d,opDat2Local,(/opDat2Cardinality/))


  sliceStart = 0
  sliceEnd = opSetCore%size
  CALL op_wrap_save_soln( &
  & opDat1Local, &
  & opDat2Local, &
  & sliceStart, sliceEnd)
  IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
    CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
  END IF

  CALL op_mpi_set_dirtybit_cuda(numberOfOpDats,opArgArray)

  call op_timers_core(endTime)

  dataTransfer = 0.0
  dataTransfer = dataTransfer + opArg1%size * getSetSizeFromOpArg(opArg1)
  dataTransfer = dataTransfer + opArg2%size * getSetSizeFromOpArg(opArg2)
  returnSetKernelTiming = setKernelTime(0 , userSubroutine//C_NULL_CHAR, &
  & endTime-startTime, dataTransfer, 0.00000_4, 1)
  calledTimes = calledTimes + 1
END SUBROUTINE
END MODULE