!
! auto-generated by op2.py
!

MODULE UPDATE_MODULE
USE OP2_CONSTANTS
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING

#ifdef _OPENMP
  USE OMP_LIB
#endif


! updatevariable declarations



CONTAINS

! user function
subroutine update_gpu(qold,q,res,adt,rms)
!$acc routine seq
  IMPLICIT NONE
  REAL(kind=8), DIMENSION(4), INTENT(IN) :: qold
  REAL(kind=8), DIMENSION(4) :: q
  REAL(kind=8), DIMENSION(4) :: res
  REAL(kind=8), INTENT(IN) :: adt
  REAL(kind=8), DIMENSION(2) :: rms
  REAL(kind=8) :: del,adti
  INTEGER(kind=4) :: i
  adti = 1.0 / adt

  DO i = 1, 4
    del = adti * res(i)
    q(i) = qold(i) - del
    res(i) = 0.0
    rms(2) = rms(2) + del * del
  END DO
END SUBROUTINE


SUBROUTINE op_wrap_update( &
  & opDat1Local, &
  & opDat2Local, &
  & opDat3Local, &
  & opDat4Local, &
  & opDat5Local, &
  & bottom,top)
  implicit none
  real(8) opDat1Local(4,*)
  real(8) opDat2Local(4,*)
  real(8) opDat3Local(4,*)
  real(8) opDat4Local(1,*)
  real(8) opDat5Local(2)

  real(8) opDat5Local_1
  real(8) opDat5Local_2
  real(8) opDat5LocalArr(2)
  INTEGER(kind=4) bottom,top,i1,i2

  opDat5Local_1 = opDat5Local(1)
  opDat5Local_2 = opDat5Local(2)

  !$acc parallel loop independent gang vector &
!$acc& deviceptr(opDat1Local) &
!$acc& deviceptr(opDat2Local) &
!$acc& deviceptr(opDat3Local) &
!$acc& deviceptr(opDat4Local) &
!$acc& reduction(+:opDat5Local_1) &
!$acc& reduction(+:opDat5Local_2) &
!$acc& private(opDat5LocalArr) 
  DO i1 = bottom, top-1, 1
    opDat5LocalArr = 0
! kernel call
    CALL update_gpu( &
    & opDat1Local(1,i1+1), &
    & opDat2Local(1,i1+1), &
    & opDat3Local(1,i1+1), &
    & opDat4Local(1,i1+1), &
    & opDat5LocalArr &
    & )
    opDat5Local_1 = opDat5Local_1 + opDat5LocalArr(1)
    opDat5Local_2 = opDat5Local_2 + opDat5LocalArr(2)
  END DO

  opDat5Local(1) = opDat5Local_1
  opDat5Local(2) = opDat5Local_2
END SUBROUTINE
SUBROUTINE update_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5

  type ( op_arg ) , DIMENSION(5) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat2Local
  INTEGER(kind=4) :: opDat2Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat3Local
  INTEGER(kind=4) :: opDat3Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat4Local
  INTEGER(kind=4) :: opDat4Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat5Local
  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  INTEGER(kind=4), SAVE :: calledTimes=0
  INTEGER(kind=4) :: sliceStart
  INTEGER(kind=4) :: sliceEnd
  REAL(kind=4) :: dataTransfer

  real(8), ALLOCATABLE, DIMENSION(:) :: opDat5LocalReduction

  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 5

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5

  returnSetKernelTiming = setKernelTime(4 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges_cuda(set%setCPtr,numberOfOpDats,opArgArray)

  opSetCore => set%setPtr

  opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
  opDat2Cardinality = opArg2%dim * getSetSizeFromOpArg(opArg2)
  opDat3Cardinality = opArg3%dim * getSetSizeFromOpArg(opArg3)
  opDat4Cardinality = opArg4%dim * getSetSizeFromOpArg(opArg4)
  CALL c_f_pointer(opArg1%data_d,opDat1Local,(/opDat1Cardinality/))
  CALL c_f_pointer(opArg2%data_d,opDat2Local,(/opDat2Cardinality/))
  CALL c_f_pointer(opArg3%data_d,opDat3Local,(/opDat3Cardinality/))
  CALL c_f_pointer(opArg4%data_d,opDat4Local,(/opDat4Cardinality/))
  CALL c_f_pointer(opArg5%data,opDat5Local, (/opArg5%dim/))
  allocate(opDat5LocalReduction(opArg5%dim)) 
  opDat5LocalReduction = opDat5Local


  sliceStart = 0
  sliceEnd = opSetCore%size
  CALL op_wrap_update( &
  & opDat1Local, &
  & opDat2Local, &
  & opDat3Local, &
  & opDat4Local, &
  & opDat5LocalReduction(1), &
  & sliceStart, sliceEnd)
  IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
    CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
  END IF
  opDat5Local = opDat5LocalReduction

  CALL op_mpi_set_dirtybit_cuda(numberOfOpDats,opArgArray)

  deallocate( opDat5LocalReduction )

  CALL op_mpi_reduce_double(opArg5,opArg5%data)

  call op_timers_core(endTime)

  dataTransfer = 0.0
  dataTransfer = dataTransfer + opArg1%size * getSetSizeFromOpArg(opArg1)
  dataTransfer = dataTransfer + opArg2%size * getSetSizeFromOpArg(opArg2)
  dataTransfer = dataTransfer + opArg3%size * getSetSizeFromOpArg(opArg3) * 2.d0
  dataTransfer = dataTransfer + opArg4%size * getSetSizeFromOpArg(opArg4)
  dataTransfer = dataTransfer + opArg5%size * 2.d0
  returnSetKernelTiming = setKernelTime(4 , userSubroutine//C_NULL_CHAR, &
  & endTime-startTime, dataTransfer, 0.00000_4, 1)
  calledTimes = calledTimes + 1
END SUBROUTINE
END MODULE