!
! auto-generated by op2.py
!

MODULE ADT_CALC_MODULE
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING
USE OP2_CONSTANTS

#ifdef _OPENMP
  USE OMP_LIB
#endif


CONTAINS

! user function
#include "adt_calc.inc"


SUBROUTINE op_wrap_adt_calc( &
  & opDat1Local, &
  & opDat5Local, &
  & opDat6Local, &
  & opDat1Map, &
  & opDat1MapDim, &
  & bottom,top)
  implicit none
  real(8) opDat1Local(2,*)
  real(8) opDat5Local(4,*)
  real(8) opDat6Local(1,*)
  INTEGER(kind=4) opDat1Map(*)
  INTEGER(kind=4) opDat1MapDim
  INTEGER(kind=4) bottom,top,i1
  INTEGER(kind=4) map1idx, map2idx, map3idx, map4idx

  DO i1 = bottom, top-1, 1
    map1idx = opDat1Map(1 + i1 * opDat1MapDim + 0)+1
    map2idx = opDat1Map(1 + i1 * opDat1MapDim + 1)+1
    map3idx = opDat1Map(1 + i1 * opDat1MapDim + 2)+1
    map4idx = opDat1Map(1 + i1 * opDat1MapDim + 3)+1
! kernel call
  CALL adt_calc( &
    & opDat1Local(1,map1idx), &
    & opDat1Local(1,map2idx), &
    & opDat1Local(1,map3idx), &
    & opDat1Local(1,map4idx), &
    & opDat5Local(1,i1+1), &
    & opDat6Local(1,i1+1) &
    & )
  END DO
END SUBROUTINE
SUBROUTINE adt_calc_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5, &
  & opArg6 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5
  type ( op_arg ) , INTENT(IN) :: opArg6

  type ( op_arg ) , DIMENSION(6) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat1Map
  INTEGER(kind=4) :: opDat1MapDim
  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat5Local
  INTEGER(kind=4) :: opDat5Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat6Local
  INTEGER(kind=4) :: opDat6Cardinality

  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  LOGICAL :: firstTime_adt_calc = .TRUE.
  type ( c_ptr )  :: planRet_adt_calc
  type ( op_plan ) , POINTER :: actualPlan_adt_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: ncolblk_adt_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: blkmap_adt_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: nelems_adt_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: offset_adt_calc
  INTEGER(kind=4), DIMENSION(1:6) :: indirectionDescriptorArray
  INTEGER(kind=4) :: numberOfIndirectOpDats
  INTEGER(kind=4) :: blockOffset
  INTEGER(kind=4) :: nblocks
  INTEGER(kind=4) :: partitionSize
  INTEGER(kind=4) :: blockID
  INTEGER(kind=4) :: nelem
  INTEGER(kind=4) :: offset_b


  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 6

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5
  opArgArray(6) = opArg6

  returnSetKernelTiming = setKernelTime(1 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges(set%setCPtr,numberOfOpDats,opArgArray)

#ifdef OP_PART_SIZE_1
  partitionSize = OP_PART_SIZE_1
#else
  partitionSize = 0
#endif

#ifdef _OPENMP
  numberOfThreads = omp_get_max_threads()
#else
  numberOfThreads = 1
#endif
    indirectionDescriptorArray(1) = 0
    indirectionDescriptorArray(2) = 0
    indirectionDescriptorArray(3) = 0
    indirectionDescriptorArray(4) = 0
    indirectionDescriptorArray(5) = -1
    indirectionDescriptorArray(6) = -1

    numberOfIndirectOpDats = 1

    planRet_adt_calc = FortranPlanCaller( &
    & userSubroutine//C_NULL_CHAR, &
    & set%setCPtr, &
    & partitionSize, &
    & numberOfOpDats, &
    & opArgArray, &
    & numberOfIndirectOpDats, &
    & indirectionDescriptorArray,2)

    CALL c_f_pointer(planRet_adt_calc,actualPlan_adt_calc)
    CALL c_f_pointer(actualPlan_adt_calc%ncolblk,ncolblk_adt_calc,(/actualPlan_adt_calc%ncolors_core/))
    CALL c_f_pointer(actualPlan_adt_calc%blkmap,blkmap_adt_calc,(/actualPlan_adt_calc%nblocks/))
    CALL c_f_pointer(actualPlan_adt_calc%offset,offset_adt_calc,(/actualPlan_adt_calc%nblocks/))
    CALL c_f_pointer(actualPlan_adt_calc%nelems,nelems_adt_calc,(/actualPlan_adt_calc%nblocks/))

    opSetCore => set%setPtr

    opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
    opDat1MapDim = getMapDimFromOpArg(opArg1)
    opDat5Cardinality = opArg5%dim * getSetSizeFromOpArg(opArg5)
    opDat6Cardinality = opArg6%dim * getSetSizeFromOpArg(opArg6)
    CALL c_f_pointer(opArg1%data,opDat1Local,(/opDat1Cardinality/))
    CALL c_f_pointer(opArg1%map_data,opDat1Map,(/opSetCore%size*opDat1MapDim/))
    CALL c_f_pointer(opArg5%data,opDat5Local,(/opDat5Cardinality/))
    CALL c_f_pointer(opArg6%data,opDat6Local,(/opDat6Cardinality/))


    blockOffset = 0

    DO i1 = 0, actualPlan_adt_calc%ncolors-1, 1
      IF (i1 .EQ. actualPlan_adt_calc%ncolors_core) THEN
        CALL op_mpi_wait_all(numberOfOpDats,opArgArray)
      END IF

      nblocks = ncolblk_adt_calc(i1 + 1)
      !$OMP PARALLEL DO private (threadID, blockID, nelem, offset_b)
      DO i2 = 0, nblocks-1, 1
        threadID = omp_get_thread_num()
        blockID = blkmap_adt_calc(i2+blockOffset+1)
        nelem = nelems_adt_calc(blockID+1)
        offset_b = offset_adt_calc(blockID+1)
        CALL op_wrap_adt_calc( &
        & opDat1Local, &
        & opDat5Local, &
        & opDat6Local, &
        & opDat1Map, &
        & opDat1MapDim, &
        & offset_b, offset_b+nelem)
      END DO
      !$OMP END PARALLEL DO
      blockOffset = blockOffset + nblocks
    END DO
    IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
      CALL op_mpi_wait_all(numberOfOpDats,opArgArray)
    END IF

    CALL op_mpi_set_dirtybit(numberOfOpDats,opArgArray)

    call op_timers_core(endTime)

    returnSetKernelTiming = setKernelTime(1 , userSubroutine//C_NULL_CHAR, &
    & endTime-startTime, actualPlan_adt_calc%transfer,actualPlan_adt_calc%transfer2, 1)
  END SUBROUTINE
  END MODULE