!
! auto-generated by op2.py
!

MODULE ADT_CALC_MODULE
USE OP2_CONSTANTS
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING

#ifdef _OPENMP
  USE OMP_LIB
#endif


! adt_calcvariable declarations



CONTAINS

! user function
SUBROUTINE adt_calc_gpu(x1,x2,x3,x4,q,adt)
  IMPLICIT NONE
  REAL(kind=8), DIMENSION(2), INTENT(IN) :: x1
  REAL(kind=8), DIMENSION(2), INTENT(IN) :: x2
  REAL(kind=8), DIMENSION(2), INTENT(IN) :: x3
  REAL(kind=8), DIMENSION(2), INTENT(IN) :: x4
  REAL(kind=8), DIMENSION(4), INTENT(IN) :: q
  REAL(kind=8) :: adt
  REAL(kind=8) :: dx,dy,ri,u,v,c

  ri = 1.0 / q(1)
  u = ri * q(2)
  v = ri * q(3)
  c = sqrt(gam * gm1 * (ri * q(4) - 0.5 * (u * u + v * v)))
  dx = x2(1) - x1(1)
  dy = x2(2) - x1(2)
  adt = abs(u * dy - v * dx) + c * sqrt(dx * dx + dy * dy)
  dx = x3(1) - x2(1)
  dy = x3(2) - x2(2)
  adt = adt + abs(u * dy - v * dx) + c * sqrt(dx * dx + dy * dy)
  dx = x4(1) - x3(1)
  dy = x4(2) - x3(2)
  adt = adt + abs(u * dy - v * dx) + c * sqrt(dx * dx + dy * dy)
  dx = x1(1) - x4(1)
  dy = x1(2) - x4(2)
  adt = adt + abs(u * dy - v * dx) + c * sqrt(dx * dx + dy * dy)
  adt = adt / cfl
END SUBROUTINE


SUBROUTINE op_wrap_adt_calc( &
  & opDat1Local, &
  & opDat1Size, &
  & opDat5Local, &
  & opDat6Local, &
  & opDat1Map, &
  & opDat1MapDim, &
  & col_reord, set_size, &
  & bottom,top,set_size_full)
  implicit none
  INTEGER(kind=4) set_size
  INTEGER(kind=4) col_reord(set_size)
  INTEGER(kind=4) set_size_full
  INTEGER(kind=4) opDat1Size
  real(8) opDat1Local(2,opDat1Size)
  real(8) opDat5Local(4,set_size_full)
  real(8) opDat6Local(1,set_size_full)
  INTEGER(kind=4) opDat1MapDim
  INTEGER(kind=4) opDat1Map(opDat1MapDim*set_size)

  INTEGER(kind=4) bottom,top,i1,i2
  INTEGER(kind=4) map1idx, map2idx, map3idx, map4idx


  !$omp target teams distribute parallel do &
!$omp& map(to:opDat1Local) &
!$omp& map(to:opDat5Local) &
!$omp& map(to:opDat6Local) &
!$omp& map(to:opDat1Map) &
!$omp& map(to:col_reord) private(i1) &
!$omp& private(map1idx) &
!$omp& private(map2idx) &
!$omp& private(map3idx) &
!$omp& private(map4idx) 
  DO i2 = bottom, top-1, 1
    i1 = col_reord(i2+1)
    map1idx = opDat1Map(1 + i1 + set_size * 0)+1
    map2idx = opDat1Map(1 + i1 + set_size * 1)+1
    map3idx = opDat1Map(1 + i1 + set_size * 2)+1
    map4idx = opDat1Map(1 + i1 + set_size * 3)+1
! kernel call
    CALL adt_calc_gpu( &
    & opDat1Local(1,map1idx), &
    & opDat1Local(1,map2idx), &
    & opDat1Local(1,map3idx), &
    & opDat1Local(1,map4idx), &
    & opDat5Local(1,i1+1), &
    & opDat6Local(1,i1+1) &
    & )
  END DO
  !$omp end target teams distribute parallel do

END SUBROUTINE
SUBROUTINE adt_calc_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5, &
  & opArg6 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5
  type ( op_arg ) , INTENT(IN) :: opArg6

  type ( op_arg ) , DIMENSION(6) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  INTEGER(kind=4), POINTER, DIMENSION(:) :: opDat1Map
  INTEGER(kind=4) :: opDat1MapDim
  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat5Local
  INTEGER(kind=4) :: opDat5Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat6Local
  INTEGER(kind=4) :: opDat6Cardinality

  INTEGER(kind=4) :: threadID
  INTEGER(kind=4) :: numberOfThreads
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  INTEGER(kind=4), SAVE :: calledTimes=0
  INTEGER(kind=4) :: exec_size
  LOGICAL :: firstTime_adt_calc = .TRUE.
  type ( c_ptr )  :: planRet_adt_calc
  type ( op_plan ) , POINTER :: actualPlan_adt_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: col_reord_adt_calc
  INTEGER(kind=4), POINTER, DIMENSION(:) :: offset_adt_calc
  INTEGER(kind=4), DIMENSION(1:6) :: indirectionDescriptorArray
  INTEGER(kind=4) :: numberOfIndirectOpDats
  INTEGER(kind=4) :: nblocks
  INTEGER(kind=4) :: partitionSize
  INTEGER(kind=4) :: blockID
  INTEGER(kind=4) :: nelem
  INTEGER(kind=4) :: offset_b


  INTEGER(kind=4) :: i1,i2,n

  numberOfOpDats = 6

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5
  opArgArray(6) = opArg6

  returnSetKernelTiming = setKernelTime(1 , userSubroutine//C_NULL_CHAR, &
  & 0.0_8, 0.00000_4,0.00000_4, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges_cuda(set%setCPtr,numberOfOpDats,opArgArray)

  opSetCore => set%setPtr

  indirectionDescriptorArray(1) = 0
  indirectionDescriptorArray(2) = 0
  indirectionDescriptorArray(3) = 0
  indirectionDescriptorArray(4) = 0
  indirectionDescriptorArray(5) = -1
  indirectionDescriptorArray(6) = -1

  exec_size = opSetCore%size + opSetCore%exec_size
  numberOfIndirectOpDats = 1

  partitionSize=0
  planRet_adt_calc = FortranPlanCaller( &
  & userSubroutine//C_NULL_CHAR, &
  & set%setCPtr, &
  & partitionSize, &
  & numberOfOpDats, &
  & opArgArray, &
  & numberOfIndirectOpDats, &
  & indirectionDescriptorArray,4)

  CALL c_f_pointer(planRet_adt_calc,actualPlan_adt_calc)
  CALL c_f_pointer(actualPlan_adt_calc%col_reord,col_reord_adt_calc,(/exec_size/))
  CALL c_f_pointer(actualPlan_adt_calc%color2_offsets,offset_adt_calc,(/actualPlan_adt_calc%ncolors+1/))
  opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
  opDat1MapDim = getMapDimFromOpArg(opArg1)
  opDat5Cardinality = opArg5%dim * getSetSizeFromOpArg(opArg5)
  opDat6Cardinality = opArg6%dim * getSetSizeFromOpArg(opArg6)
  CALL c_f_pointer(opArg1%data_d,opDat1Local,(/opDat1Cardinality/))
  CALL c_f_pointer(opArg1%map_data_d,opDat1Map,(/exec_size*opDat1MapDim/))
  CALL c_f_pointer(opArg5%data_d,opDat5Local,(/opDat5Cardinality/))
  CALL c_f_pointer(opArg6%data_d,opDat6Local,(/opDat6Cardinality/))



  DO i1 = 0, actualPlan_adt_calc%ncolors-1, 1
    IF (i1 .EQ. 1) THEN
      CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
    END IF

    offset_b = offset_adt_calc(i1 + 1)
    nelem = offset_adt_calc(i1 + 1 + 1)
    CALL op_wrap_adt_calc( &
    & opDat1Local, &
    & getSetSizeFromOpArg(opArg1), &
    & opDat5Local, &
    & opDat6Local, &
    & opDat1Map, &
    & opDat1MapDim, &
    & col_reord_adt_calc, exec_size, offset_b, nelem, exec_size+opSetCore%nonexec_size )
  END DO
  IF ((n_upper .EQ. 0) .OR. (n_upper .EQ. opSetCore%core_size)) THEN
    CALL op_mpi_wait_all_cuda(numberOfOpDats,opArgArray)
  END IF

  CALL op_mpi_set_dirtybit_cuda(numberOfOpDats,opArgArray)

  call op_timers_core(endTime)

  returnSetKernelTiming = setKernelTime(1 , userSubroutine//C_NULL_CHAR, &
  & endTime-startTime, actualPlan_adt_calc%transfer,actualPlan_adt_calc%transfer2, 1)
  calledTimes = calledTimes + 1
END SUBROUTINE
END MODULE