!
! auto-generated by op2_fortran.py
!

MODULE UPDATE_MODULE
USE OP2_FORTRAN_DECLARATIONS
USE OP2_FORTRAN_RT_SUPPORT
USE ISO_C_BINDING
USE OP2_CONSTANTS


CONTAINS

! user function
SUBROUTINE update(qold,q,res,adt,rms)
  IMPLICIT NONE
  REAL(kind=8), DIMENSION(4), INTENT(IN) :: qold
  REAL(kind=8), DIMENSION(4) :: q
  REAL(kind=8), DIMENSION(4) :: res
  REAL(kind=8), INTENT(IN) :: adt
  REAL(kind=8), DIMENSION(2) :: rms
  REAL(kind=8) :: del,adti
  INTEGER(kind=4) :: i
  adti = 1.0 / adt

  DO i = 1, 4
    del = adti * res(i)
    q(i) = qold(i) - del
    res(i) = 0.0
    rms(2) = rms(2) + del * del
  END DO
END SUBROUTINE

#define SIMD_VEC 4
#define VECTORIZE

SUBROUTINE op_wrap_update( &
  & opDat1Local, &
  & opDat2Local, &
  & opDat3Local, &
  & opDat4Local, &
  & opDat5Local, &
  & bottom,top)
  implicit none
  real(8) opDat1Local(4,*)
  real(8) opDat2Local(4,*)
  real(8) opDat3Local(4,*)
  real(8) opDat4Local(1,*)
  real(8) opDat5Local(2)
  INTEGER(kind=4) bottom,top,i1, i2
  real(8) dat5(SIMD_VEC*2)
  !dir$ attributes align: 64:: dat5

  !DIR$ ASSUME_ALIGNED opDat1Local : 64
  !DIR$ ASSUME_ALIGNED opDat2Local : 64
  !DIR$ ASSUME_ALIGNED opDat3Local : 64
  !DIR$ ASSUME_ALIGNED opDat4Local : 64
#ifdef VECTORIZE
  DO i1 = bottom, ((top-1)/SIMD_VEC)*SIMD_VEC-1, SIMD_VEC
    dat5 = 0.0_8
    !DIR$ SIMD
    !DIR$ FORCEINLINE
    DO i2 = 1, SIMD_VEC, 1
      ! vectorized kernel call
      CALL update( &
      & opDat1Local(1,(i1+i2-1)+1), &
      & opDat2Local(1,(i1+i2-1)+1), &
      & opDat3Local(1,(i1+i2-1)+1), &
      & opDat4Local(1,(i1+i2-1)+1), &
      & dat5(2*(i2-1)+1:2*(i2-1)+2) &
      & )
    END DO

    DO i2 = 1, SIMD_VEC, 1
      opDat5Local(1:(2)) = opDat5Local(1:(2)) + dat5((2)*(i2-1)+1:(2)*(i2-1)+(2))
    END DO
  END DO
  ! remainder
  DO i1 = ((top-1)/SIMD_VEC)*SIMD_VEC, top-1, 1
#else
  !DIR$ FORCEINLINE
  DO i1 = bottom, top-1, 1
#endif
    ! kernel call
    CALL update( &
    & opDat1Local(1,i1+1), &
    & opDat2Local(1,i1+1), &
    & opDat3Local(1,i1+1), &
    & opDat4Local(1,i1+1), &
    & opDat5Local(1) &
    & )
  END DO
END SUBROUTINE
SUBROUTINE update_host( userSubroutine, set, &
  & opArg1, &
  & opArg2, &
  & opArg3, &
  & opArg4, &
  & opArg5 )

  IMPLICIT NONE
  character(kind=c_char,len=*), INTENT(IN) :: userSubroutine
  type ( op_set ) , INTENT(IN) :: set

  type ( op_arg ) , INTENT(IN) :: opArg1
  type ( op_arg ) , INTENT(IN) :: opArg2
  type ( op_arg ) , INTENT(IN) :: opArg3
  type ( op_arg ) , INTENT(IN) :: opArg4
  type ( op_arg ) , INTENT(IN) :: opArg5

  type ( op_arg ) , DIMENSION(5) :: opArgArray
  INTEGER(kind=4) :: numberOfOpDats
  REAL(kind=4) :: dataTransfer
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayStart
  INTEGER(kind=4), DIMENSION(1:8) :: timeArrayEnd
  REAL(kind=8) :: startTime
  REAL(kind=8) :: endTime
  INTEGER(kind=4) :: returnSetKernelTiming
  INTEGER(kind=4) :: n_upper
  type ( op_set_core ) , POINTER :: opSetCore

  real(8), POINTER, DIMENSION(:) :: opDat1Local
  INTEGER(kind=4) :: opDat1Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat2Local
  INTEGER(kind=4) :: opDat2Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat3Local
  INTEGER(kind=4) :: opDat3Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat4Local
  INTEGER(kind=4) :: opDat4Cardinality

  real(8), POINTER, DIMENSION(:) :: opDat5Local

  INTEGER(kind=4) :: i1

  numberOfOpDats = 5

  opArgArray(1) = opArg1
  opArgArray(2) = opArg2
  opArgArray(3) = opArg3
  opArgArray(4) = opArg4
  opArgArray(5) = opArg5

  returnSetKernelTiming = setKernelTime(4 , userSubroutine//C_NULL_CHAR, &
  & 0.d0, 0.00000,0.00000, 0)
  call op_timers_core(startTime)

  n_upper = op_mpi_halo_exchanges(set%setCPtr,numberOfOpDats,opArgArray)

  opSetCore => set%setPtr

  opDat1Cardinality = opArg1%dim * getSetSizeFromOpArg(opArg1)
  opDat2Cardinality = opArg2%dim * getSetSizeFromOpArg(opArg2)
  opDat3Cardinality = opArg3%dim * getSetSizeFromOpArg(opArg3)
  opDat4Cardinality = opArg4%dim * getSetSizeFromOpArg(opArg4)
  CALL c_f_pointer(opArg1%data,opDat1Local,(/opDat1Cardinality/))
  CALL c_f_pointer(opArg2%data,opDat2Local,(/opDat2Cardinality/))
  CALL c_f_pointer(opArg3%data,opDat3Local,(/opDat3Cardinality/))
  CALL c_f_pointer(opArg4%data,opDat4Local,(/opDat4Cardinality/))
  CALL c_f_pointer(opArg5%data,opDat5Local, (/opArg5%dim/))


  CALL op_mpi_wait_all(numberOfOpDats,opArgArray)
  CALL op_wrap_update( &
  & opDat1Local, &
  & opDat2Local, &
  & opDat3Local, &
  & opDat4Local, &
  & opDat5Local, &
  & 0, n_upper)

  CALL op_mpi_set_dirtybit(numberOfOpDats,opArgArray)

  CALL op_mpi_reduce_double(opArg5,opArg5%data)

  call op_timers_core(endTime)

  dataTransfer = 0.0
  dataTransfer = dataTransfer + opArg1%size * opSetCore%size
  dataTransfer = dataTransfer + opArg2%size * opSetCore%size
  dataTransfer = dataTransfer + opArg3%size * opSetCore%size * 2.d0
  dataTransfer = dataTransfer + opArg4%size * opSetCore%size
  dataTransfer = dataTransfer + opArg5%size * 2.d0
  returnSetKernelTiming = setKernelTime(4 , userSubroutine//C_NULL_CHAR, &
  & endTime-startTime, dataTransfer, 0.00000_4, 1)

END SUBROUTINE
END MODULE